
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>iOS开发 贝塞尔曲线的使用总结 / 憋错料</title>

    <meta name="description" content="iOS开发 贝塞尔曲线的使用总结 iOS开发 贝塞尔曲线UIBezierPath 最近项目中需要用到用贝塞尔曲线去绘制路径 ,然后往路径里面填充图片,找到这篇文章挺好,记录下来 自己学习! 转至 http://blog.csdn.net/guo_hongjun1611/article/details/7839371 使用UIBezierPath类可以创建基于矢量的路径,这个类在UIKit中.此类是Core Graphics框架关于path的一个封装.使用此类可以定义简单的形状,如椭圆或者矩形,或者有多个直线和曲线段组成的形状.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">iOS开发 贝塞尔曲线的使用总结</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2><a href="http://www.cnblogs.com/moyunmo/p/3600091.html" rel="external nofollow noreferrer">iOS开发 贝塞尔曲线UIBezierPath</a></h2>
<p>最近项目中需要用到用贝塞尔曲线去绘制路径 ，然后往路径里面填充图片，找到这篇文章挺好，记录下来 自己学习！ 转至&nbsp;http://blog.csdn.net/guo_hongjun1611/article/details/7839371</p>
<p>使用UIBezierPath类可以创建基于矢量的路径，这个类在UIKit中。此类是Core Graphics框架关于path的一个封装。使用此类可以定义简单的形状，如椭圆或者矩形，或者有多个直线和曲线段组成的形状。</p>

<p>1.Bezier Path 基础</p>
<p>UIBezierPath对象是CGPathRef数据类型的封装。path如果是基于矢量形状的，都用直线和曲线段去创建。&nbsp;&nbsp;我们使用直线段去创建矩形和多边形，使用曲线段去创建弧（arc），圆或者其他复杂的曲线形状。&nbsp;每一段都包括一个或者多个点，绘图命令定义如何去诠释这些点。每一个直线段或者曲线段的结束的地方是下一个的开始的地方。每一个连接的直线或者曲线段的集合成为subpath。一个UIBezierPath对象定义一个完整的路径包括一个或者多个subpaths。</p>

<p>创建和使用一个path对象的过程是分开的。创建path是第一步，包含一下步骤：</p>
<p>（1）创建一个Bezier&nbsp;path对象。</p>
<p>（2）使用方法moveToPoint:去设置初始线段的起点。</p>
<p>（3）添加line或者curve去定义一个或者多个subpaths。</p>
<p>（4）改变UIBezierPath对象跟绘图相关的属性。</p>
<p>例如，我们可以设置stroked path的属性lineWidth和lineJoinStyle。也可以设置filled path的属性usesEvenOddFillRule。</p>

<p>当创建path，我们应该管理path上面的点相对于原点（0，0），这样我们在随后就可以很容易的移动path了。为了绘制path对象，我们要用到stroke和fill方法。这些方法在current graphic context下渲染path的line和curve段。</p>


<p>2、使用UIBezierPath创建多边形---在path下面添加直线条形成多边形</p>
<p>多边形是一些简单的形状,这些形状是由一些直线线条组成，我们可以用moveToPoint: 和 addLineToPoint:方法去构建。</p>
<p>方法moveToPoint:设置我们想要创建形状的起点。从这点开始，我们可以用方法addLineToPoint:去创建一个形状的线段。</p>
<p>我们可以连续的创建line，每一个line的起点都是先前的终点，终点就是指定的点。</p>

<p>下面的代码描述了如何用线段去创建一个五边形。第五条线通过调用closePath方法得到的，它连接了最后一个点（0，40）和第一个点（100，0）</p>
<p>说明：closePath方法不仅结束一个shape的subpath表述，它也在最后一个点和第一个点之间画一条线段，如果我们画多边形的话，这个一个便利的方法我们不需要去画最后一条线。</p>

<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>//&nbsp;Only&nbsp;override&nbsp;drawRect:&nbsp;if&nbsp;you&nbsp;perform&nbsp;custom&nbsp;drawing.</li>
<li>-&nbsp;(&nbsp;&nbsp;void&nbsp;)drawRect:(CGRect)rect</li>
<li>{</li>
<li>UIColor&nbsp;*color&nbsp;=&nbsp;[UIColor&nbsp;redColor];</li>
<li>[color&nbsp;set];&nbsp;&nbsp;&nbsp;//设置线条颜色</li>
<li>UIBezierPath*&nbsp;aPath&nbsp;=&nbsp;[UIBezierPath&nbsp;bezierPath];</li>
<li>aPath.lineWidth&nbsp;=&nbsp;5.0;</li>
<li>aPath.lineCapStyle&nbsp;=&nbsp;kCGLineCapRound;&nbsp;&nbsp;&nbsp;//线条拐角</li>
<li>aPath.lineJoinStyle&nbsp;=&nbsp;kCGLineCapRound;&nbsp;&nbsp;&nbsp;//终点处理</li>
<li>//&nbsp;Set&nbsp;the&nbsp;starting&nbsp;point&nbsp;of&nbsp;the&nbsp;shape.</li>
<li>[aPath&nbsp;moveToPoint:CGPointMake(100.0,&nbsp;0.0)];</li>
<li>//&nbsp;Draw&nbsp;the&nbsp;lines</li>
<li>[aPath&nbsp;addLineToPoint:CGPointMake(200.0,&nbsp;40.0)];</li>
<li>[aPath&nbsp;addLineToPoint:CGPointMake(160,&nbsp;140)];</li>
<li>[aPath&nbsp;addLineToPoint:CGPointMake(40.0,&nbsp;140)];</li>
<li>[aPath&nbsp;addLineToPoint:CGPointMake(0.0,&nbsp;40.0)];</li>
<li>[aPath&nbsp;closePath];&nbsp;&nbsp;//第五条线通过调用closePath方法得到的</li>
<li>[aPath&nbsp;stroke];&nbsp;&nbsp;//Draws&nbsp;line&nbsp;根据坐标点连线</li>
<li>}</li>
</ol>
<p>注：这个类要继承自UIView。</p>

<p>运行的结果如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMi50dWljb29sLmNvbS92SU5qMnkuanBnIXdlYg==.jpg" /></p>

<p>如果修改最后一句代码：&nbsp;[aPath&nbsp;fill&nbsp;];</p>
<p>运行结果就如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMC50dWljb29sLmNvbS9FbnlNYmkuanBnIXdlYg==.jpg" /></p>

<p>这样就知道&nbsp;&nbsp;stroke &nbsp;和 &nbsp;fill &nbsp;方法的区别&nbsp;了吧！</p>

<p>3、使用UIBezierPath创建矩形</p>
<p>使用这个方法即可：</p>
<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>Creates&nbsp;and&nbsp;returns&nbsp;a&nbsp;&nbsp;new&nbsp;UIBezierPath&nbsp;object&nbsp;initialized&nbsp;with&nbsp;a&nbsp;rectangular&nbsp;path.</li>
<li>+&nbsp;(UIBezierPath&nbsp;*)bezierPathWithRect:(CGRect)rect</li>
</ol>
<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>-&nbsp;(&nbsp;void&nbsp;)drawRect:(CGRect)rect</li>
<li>{</li>
<li>UIColor&nbsp;*color&nbsp;=&nbsp;[UIColor&nbsp;redColor];</li>
<li>[color&nbsp;set];&nbsp;&nbsp;&nbsp;//设置线条颜色</li>
<li>UIBezierPath*&nbsp;aPath&nbsp;=&nbsp;[UIBezierPath&nbsp;bezierPathWithRect:CGRectMake(20,&nbsp;20,&nbsp;100,&nbsp;50)];</li>
<li>aPath.lineWidth&nbsp;=&nbsp;5.0;</li>
<li>aPath.lineCapStyle&nbsp;=&nbsp;kCGLineCapRound;&nbsp;&nbsp;&nbsp;//线条拐角</li>
<li>aPath.lineJoinStyle&nbsp;=&nbsp;kCGLineCapRound;&nbsp;&nbsp;&nbsp;//终点处理</li>
<li>[aPath&nbsp;stroke];</li>
<li>}</li>
</ol>
<p>4、&nbsp;&nbsp;使用&nbsp;UIBezierPath创建圆形或者椭圆形</p>
<p>使用这个方法即可：</p>
<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>Creates&nbsp;and&nbsp;returns&nbsp;a&nbsp;&nbsp;new&nbsp;UIBezierPath&nbsp;object&nbsp;initialized&nbsp;with&nbsp;an&nbsp;oval&nbsp;path&nbsp;inscribed&nbsp;in&nbsp;the&nbsp;specified&nbsp;rectangle</li>
<li>+&nbsp;(UIBezierPath&nbsp;*)bezierPathWithOvalInRect:(CGRect)rect</li>
</ol>
<p>这个方法根据传入的rect矩形参数绘制一个内切曲线。</p>
<p>当传入的rect是一个正方形时，绘制的图像是一个内切圆；当传入的rect是一个长方形时，绘制的图像是一个内切椭圆。</p>

<p>5、使用UIBezierPath创建一段弧线</p>
<p>使用这个方法：</p>

<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>Creates&nbsp;and&nbsp;returns&nbsp;a&nbsp;&nbsp;new&nbsp;UIBezierPath&nbsp;object&nbsp;initialized&nbsp;with&nbsp;an&nbsp;arc&nbsp;of&nbsp;a&nbsp;circle.</li>
<li>+&nbsp;(UIBezierPath&nbsp;*)bezierPathWithArcCenter:(CGPoint)center&nbsp;radius:(CGFloat)radius&nbsp;startAngle:(CGFloat)startAngle&nbsp;endAngle:(CGFloat)endAngle&nbsp;clockwise:(&nbsp;&nbsp;BOOL&nbsp;)clockwise</li>
<li>Parameters</li>
<li>center</li>
<li>Specifies&nbsp;the&nbsp;center&nbsp;point&nbsp;of&nbsp;the&nbsp;circle&nbsp;(in&nbsp;the&nbsp;current&nbsp;coordinate&nbsp;system)&nbsp;used&nbsp;to&nbsp;define&nbsp;the&nbsp;arc.</li>
<li>radius</li>
<li>Specifies&nbsp;the&nbsp;radius&nbsp;of&nbsp;the&nbsp;circle&nbsp;used&nbsp;to&nbsp;define&nbsp;the&nbsp;arc.</li>
<li>startAngle</li>
<li>Specifies&nbsp;the&nbsp;starting&nbsp;angle&nbsp;of&nbsp;the&nbsp;arc&nbsp;(measured&nbsp;in&nbsp;radians).</li>
<li>endAngle</li>
<li>Specifies&nbsp;the&nbsp;end&nbsp;angle&nbsp;of&nbsp;the&nbsp;arc&nbsp;(measured&nbsp;in&nbsp;radians).</li>
<li>clockwise</li>
<li>The&nbsp;direction&nbsp;in&nbsp;which&nbsp;to&nbsp;draw&nbsp;the&nbsp;arc.</li>
<li>Return&nbsp;Value</li>
<li>A&nbsp;&nbsp;&nbsp;new&nbsp;&nbsp;path&nbsp;object&nbsp;with&nbsp;the&nbsp;specified&nbsp;arc.</li>
</ol>

<p>其中的参数分别指定：这段圆弧的中心，半径，开始角度，结束角度，是否顺时针方向。</p>

<p>下图为弧线的参考系。</p>

<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50dWljb29sLmNvbS9ZUmY2Rm4uanBnIXdlYg==.jpg" /></p>
<p>demo代码：</p>
<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>#define&nbsp;pi&nbsp;3.14159265359</li>
<li>#define&nbsp;&nbsp;&nbsp;DEGREES_TO_RADIANS(degrees)&nbsp;&nbsp;((pi&nbsp;*&nbsp;degrees)/&nbsp;180)</li>
</ol>

<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>-&nbsp;(&nbsp;void&nbsp;)drawRect:(CGRect)rect</li>
<li>{</li>
<li>UIColor&nbsp;*color&nbsp;=&nbsp;[UIColor&nbsp;redColor];</li>
<li>[color&nbsp;set];&nbsp;&nbsp;&nbsp;//设置线条颜色</li>
<li>UIBezierPath*&nbsp;aPath&nbsp;=&nbsp;[UIBezierPath&nbsp;bezierPathWithArcCenter:CGPointMake(150,&nbsp;150)</li>
<li>radius:75</li>
<li>startAngle:0</li>
<li>endAngle:DEGREES_TO_RADIANS(135)</li>
<li>clockwise:YES];</li>
<li>aPath.lineWidth&nbsp;=&nbsp;5.0;</li>
<li>aPath.lineCapStyle&nbsp;=&nbsp;kCGLineCapRound;&nbsp;&nbsp;&nbsp;//线条拐角</li>
<li>aPath.lineJoinStyle&nbsp;=&nbsp;kCGLineCapRound;&nbsp;&nbsp;&nbsp;//终点处理</li>
<li>[aPath&nbsp;stroke];</li>
<li>}</li>
</ol>

<p>结果如下图：&nbsp;&nbsp;<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMi50dWljb29sLmNvbS9qSW5FcnkuanBnIXdlYg==.jpg" /></p>

<p>6、UIBezierPath类提供了添加二次贝塞尔曲线和三次贝塞尔曲线的支持。</p>
<p>曲线段在当前点开始，在指定的点结束。曲线的形状有开始点，结束点，一个或者多个控制点的切线定义。下图显示了两种曲线类型的相似，以及控制点和curve形状的关系。</p>

<p>(1)绘制二次贝塞尔曲线</p>

<p>使用到这个方法：</p>
<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>Appends&nbsp;a&nbsp;quadratic&nbsp;B&eacute;zier&nbsp;curve&nbsp;to&nbsp;the&nbsp;receiver&rsquo;s&nbsp;path.</li>
<li>-&nbsp;(&nbsp;&nbsp;void&nbsp;)addQuadCurveToPoint:(CGPoint)endPoint&nbsp;controlPoint:(CGPoint)controlPoint</li>
<li>Parameters</li>
<li>endPoint</li>
<li>The&nbsp;end&nbsp;point&nbsp;of&nbsp;the&nbsp;curve.</li>
<li>controlPoint</li>
<li>The&nbsp;control&nbsp;point&nbsp;of&nbsp;the&nbsp;curve.</li>
</ol>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMC50dWljb29sLmNvbS9qZTJRRnYuanBnIXdlYg==.jpg" /></p>

<p>demo代码：</p>
<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>-&nbsp;(&nbsp;void&nbsp;)drawRect:(CGRect)rect</li>
<li>{</li>
<li>UIColor&nbsp;*color&nbsp;=&nbsp;[UIColor&nbsp;redColor];</li>
<li>[color&nbsp;set];&nbsp;&nbsp;&nbsp;//设置线条颜色</li>
<li>UIBezierPath*&nbsp;aPath&nbsp;=&nbsp;[UIBezierPath&nbsp;bezierPath];</li>
<li>aPath.lineWidth&nbsp;=&nbsp;5.0;</li>
<li>aPath.lineCapStyle&nbsp;=&nbsp;kCGLineCapRound;&nbsp;&nbsp;&nbsp;//线条拐角</li>
<li>aPath.lineJoinStyle&nbsp;=&nbsp;kCGLineCapRound;&nbsp;&nbsp;&nbsp;//终点处理</li>
<li>[aPath&nbsp;moveToPoint:CGPointMake(20,&nbsp;100)];</li>
<li>[aPath&nbsp;addQuadCurveToPoint:CGPointMake(120,&nbsp;100)&nbsp;controlPoint:CGPointMake(70,&nbsp;0)];</li>
<li>[aPath&nbsp;stroke];</li>
<li>}</li>
</ol>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50dWljb29sLmNvbS9qdUlGMzIuanBnIXdlYg==.jpg" /></p>


<p>(2)绘制三次贝塞尔曲线</p>

<p>使用到这个方法：</p>
<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>Appends&nbsp;a&nbsp;cubic&nbsp;B&eacute;zier&nbsp;curve&nbsp;to&nbsp;the&nbsp;receiver&rsquo;s&nbsp;path.</li>
<li>-&nbsp;(&nbsp;&nbsp;void&nbsp;)addCurveToPoint:(CGPoint)endPoint&nbsp;controlPoint1:(CGPoint)controlPoint1&nbsp;controlPoint2:(CGPoint)controlPoint2</li>
<li>Parameters</li>
<li>endPoint</li>
<li>The&nbsp;end&nbsp;point&nbsp;of&nbsp;the&nbsp;curve.</li>
<li>controlPoint1</li>
<li>The&nbsp;first&nbsp;control&nbsp;point&nbsp;to&nbsp;use&nbsp;when&nbsp;computing&nbsp;the&nbsp;curve.</li>
<li>controlPoint2</li>
<li>The&nbsp;second&nbsp;control&nbsp;point&nbsp;to&nbsp;use&nbsp;when&nbsp;computing&nbsp;the&nbsp;curve.</li>
</ol>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50dWljb29sLmNvbS9RQlJqMmEuanBnIXdlYg==.jpg" /></p>

<p>demo代码：</p>
<p><strong>[cpp]</strong>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="http://blog.csdn.net/crayondeng/article/details/11093689" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>-&nbsp;(&nbsp;void&nbsp;)drawRect:(CGRect)rect</li>
<li>{</li>
<li>UIColor&nbsp;*color&nbsp;=&nbsp;[UIColor&nbsp;redColor];</li>
<li>[color&nbsp;set];&nbsp;&nbsp;&nbsp;//设置线条颜色</li>
<li>UIBezierPath*&nbsp;aPath&nbsp;=&nbsp;[UIBezierPath&nbsp;bezierPath];</li>
<li>aPath.lineWidth&nbsp;=&nbsp;5.0;</li>
<li>aPath.lineCapStyle&nbsp;=&nbsp;kCGLineCapRound;&nbsp;&nbsp;&nbsp;//线条拐角</li>
<li>aPath.lineJoinStyle&nbsp;=&nbsp;kCGLineCapRound;&nbsp;&nbsp;&nbsp;//终点处理</li>
<li>[aPath&nbsp;moveToPoint:CGPointMake(20,&nbsp;50)];</li>
<li>[aPath&nbsp;addCurveToPoint:CGPointMake(200,&nbsp;50)&nbsp;controlPoint1:CGPointMake(110,&nbsp;0)&nbsp;controlPoint2:CGPointMake(110,&nbsp;100)];</li>
<li>[aPath&nbsp;stroke];</li>
<li>}</li>
</ol>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50dWljb29sLmNvbS82QmppdXEuanBnIXdlYg==.jpg" /></p>

<p>7.使用Core Graphics函数去修改path。</p>
<p>UIBezierPath类只是CGPathRef数据类型和path绘图属性的一个封装。虽然通常我们可以用UIBezierPath类的方法去添加直线段和曲线段，UIBezierPath类还提供了一个属性CGPath，我们可以用来直接修改底层的path data type。如果我们希望用Core Graphics 框架函数去创建path，则我们要用到此属性。</p>

<p>有两种方法可以用来修改和UIBezierPath对象相关的path。可以完全的使用Core Graphics函数去修改path，也可以使用Core Graphics函数和UIBezierPath函数混合去修改。第一种方法在某些方面相对来说比较容易。我们可以创建一个CGPathRef数据类型，并调用我们需要修改path信息的函数。</p>
<p>下面的代码就是赋值一个新的CGPathRef给UIBezierPath对象。</p>
<table>
<tbody>
<tr>
<td scope="row">
<pre>// Create the path data</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGMutablePathRef cgPath = CGPathCreateMutable();</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGPathAddEllipseInRect(cgPath, NULL, CGRectMake(0, 0, 300, 300));</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGPathAddEllipseInRect(cgPath, NULL, CGRectMake(50, 50, 200, 200));</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// Now create the UIBezierPath object</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>UIBezierPath* aPath = [UIBezierPath bezierPath];</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>aPath.CGPath = cgPath;</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>aPath.usesEvenOddFillRule = YES;</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// After assigning it to the UIBezierPath object, you can release</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// your CGPathRef data type safely.</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGPathRelease(cgPath);</pre>
</td>
</tr>
</tbody>
</table>
<p>如果我们使用Core Graphics函数和UIBezierPath函数混合方法，我们必须小心的移动path 信息在两者之间。因为UIBezierPath类拥有自己底层的CGPathRef data type，我们不能简单的检索该类型并直接的修改它。相反，我们应该生成一个副本，然后修改此副本，然后赋值此副本给CGPath属性，如下代码：</p>
<p>Mixing Core Graphics and&nbsp;&nbsp;&nbsp;<code>UIBezierPath</code>&nbsp;&nbsp;calls</p>
<table>
<tbody>
<tr>
<td scope="row">
<pre>UIBezierPath*    aPath = [UIBezierPath bezierPathWithOvalInRect:CGRectMake(0, 0, 300, 300)];</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// Get the CGPathRef and create a mutable version.</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGPathRef cgPath = aPath.CGPath;</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGMutablePathRef  mutablePath = CGPathCreateMutableCopy(cgPath);</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// Modify the path and assign it back to the UIBezierPath object</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGPathAddEllipseInRect(mutablePath, NULL, CGRectMake(50, 50, 200, 200));</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>aPath.CGPath = mutablePath;</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// Release both the mutable copy of the path.</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGPathRelease(mutablePath);</pre>
</td>
</tr>
</tbody>
</table>
<p>8.rendering（渲染）Bezier Path对象的内容。</p>
<p>当创建一个UIBezierPath对象之后，我们可以使用它的stroke和fill方法在current graphics context中去渲染它。在调用这些方法之前，我们要进行一些其他的任务去确保正确的绘制path。</p>
<p>使用UIColor类的方法去stroke和fill想要的颜色。</p>
<p>设置形状在目标视图中的位置。如果我们创建的path相对于原点（0，0），则我们可以给current drawing context应用一个适当的affie transform。例如，我想drawing一个形状起始点在（0，0），我可以调用函数CGContextTranslateCTM,并指定水平和垂直方向的translation值为10。调整graphic context相对于调整path对象的points是首选的方法，因为我们可以很容易的保存和撤销先前的graphics state。</p>
<p>更新path对象的drawing 属性。当渲染path时，UIBezierPath实例的drawing属性会覆盖graphics context下的属性值。</p>

<p>下面的代码实现了在一个自定义view中实现drawRect：方法中去绘制一个椭圆。椭圆边框矩形的左上角位于视图坐标系统的点（50，50）处。</p>
<p>Drawing a path in a view</p>
<table>
<tbody>
<tr>
<td scope="row">
<pre>- (void)drawRect:(CGRect)rect</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>{</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// Create an oval shape to draw.</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>UIBezierPath* aPath = [UIBezierPath bezierPathWithOvalInRect:</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGRectMake(0, 0, 200, 100)];</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// Set the render colors</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>[[UIColor blackColor] setStroke];</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>[[UIColor redColor] setFill];</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGContextRef aRef = UIGraphicsGetCurrentContext();</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// If you have content to draw after the shape,</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// save the current state before changing the transform</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>//CGContextSaveGState(aRef);</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// Adjust the view‘s origin temporarily. The oval is</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// now drawn relative to the new origin point.</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>CGContextTranslateCTM(aRef, 50, 50);</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// Adjust the drawing options as needed.</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>aPath.lineWidth = 5;</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// Fill the path before stroking it so that the fill</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// color does not obscure the stroked line.</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>[aPath fill];</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>[aPath stroke];</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>// Restore the graphics state before drawing any other content.</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>//CGContextRestoreGState(aRef);</pre>
</td>
</tr>
<tr>
<td scope="row">
<pre>}</pre>
</td>
</tr>
</tbody>
</table>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-13 14:55:08 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>iOS开发 贝塞尔曲线的使用总结的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nE6PKM.html" rel="bookmark">iOS开发 贝塞尔曲线UIBezierPath（2）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用CAShapeLayer与UIBezierPath可以实现不在view的drawRect方法中就画出一些想要的图形 . 1:UIBezierPath: UIBezierPath是在 UIKit 中的一个类,继承于NSObject,可以创建基于矢量的路径.此类是Core Graphics框架关于path的一个OC封装.使用此类可以定义常见的圆形.多边形等形状 .我们使用直线.弧(arc)来创建复杂的曲线形状.每一个直线段或者曲线段的结束的地方是下一个的开始的地方.每一个连接的直线或者曲线段的集			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzQko84.html" rel="bookmark">iOS开发 贝塞尔曲线UIBezierPath</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用UIBezierPath类可以创建基于矢量的路径,这个类在UIKit中.此类是Core Graphics框架关于path的一个封装.使用此类可以定义简单的形状,如椭圆或者矩形,或者有多个直线和曲线段组成的形状. 1.Bezier Path 基础 UIBezierPath对象是CGPathRef数据类型的封装.path如果是基于矢量形状的,都用直线和曲线段去创建.我们使用直线段去创建矩形和多边形,使用曲线段去创建弧(arc),圆或者其他复杂的曲线形状.每一段都包括一个或者多个点,绘图命令定义如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGemzG3.html" rel="bookmark">iOS 使用贝塞尔曲线绘制路径</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用贝塞尔曲线绘制路径 大多数时候,我们在开发中使用的控件的边框是矩形,或者做一点圆角,是使得矩形的角看起来更加的圆滑. 但是如果我们想要一个不规则的图形怎么办?有人说,叫UI妹子做,不仅省事,还可以趁机接近她们(_:D).这又时候确实可以.但是如果是一个时刻变动的不规则图形,这样如果做成动图或者剪出很多张图,再叫UI妹子做的话,似乎也能解决, 但是实际效果吧,呵呵. 更重要的是从此以后UI妹子不仅不愿搭理你,连以后接触的机会都不会再给你了.好吧,iOS中我们其实不需要担心这个问题.使用UIBe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/V02rV20.html" rel="bookmark">iOS&colon;使用贝塞尔曲线绘制图表（折线图、柱状图、饼状图）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.介绍: UIBezierPath :画贝塞尔曲线的path类 UIBezierPath定义 : 贝赛尔曲线的每一个顶点都有两个控制点,用于控制在该顶点两侧的曲线的弧度. 曲线的定义有四个点:起始点.终止点(也称锚点)以及两个相互分离的中间点. 滑动两个中间点,贝塞尔曲线的形状会发生变化. UIBezierPath :对象是CGPathRef数据类型的封装,可以方便的让我们画出 矩形 . 椭圆 或者 直线和曲线的组合形状 初始化方法: + (instancetype)bezierPath; /			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QpPJe3.html" rel="bookmark">iOS之贝塞尔曲线</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这段时间一直在探索一些新奇的事物,博客一直没有更新.今天我们来学一些好玩的东西.比如利用facebook的pop,做一个会动的贝塞尔曲线.废话不多说,来看看吧. #import &quot;Beisaier.h&quot; #import &lt;pop/POP.h&gt; @interface Beisaier () { CAShapeLayer *layer1; UIBezierPath *aPath1; } @end @implementation Beisaier - (void)viewDidL			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49vbeAM.html" rel="bookmark">iOS开发之画图板&lpar;贝塞尔曲线&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				贝塞尔曲线,听着挺牛气一词,不过下面我们在做画图板的时候就用到贝塞尔绘直线,没用到绘制曲线的功能.如果会点PS的小伙伴会对贝塞尔曲线有更直观的理解.这篇博文的重点不在于如何用使用贝塞尔曲线,而是利用贝塞尔划线的功能来封装一个画图板. 画图板的截图如下,上面的白板就是我们的画图板,是自己封装好的一个UIView,下面会详细的介绍如何封装这个画图板,下面的控件用来控制我们画图板的属性以及Undo,Redo和保存功能.点击保存时会把绘制的图片保存到手机的相册中.下面是具体的实现方案. 一.封装画图板			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4N15ZB3.html" rel="bookmark">贝塞尔曲线开发的艺术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				贝塞尔曲线开发的艺术 一句话概括贝塞尔曲线:将任意一条曲线转化为精确的数学公式. 很多绘图工具中的钢笔工具,就是典型的贝塞尔曲线的应用,这里的一个网站可以在线模拟钢笔工具的使用: http://bezier.method.ac/ 贝塞尔曲线中有一些比较关键的名词,解释如下: 数据点:通常指一条路径的起始点和终止点 控制点:控制点决定了一条路径的弯曲轨迹,根据控制点的个数,贝塞尔曲线被分为一阶贝塞尔曲线(0个控制点).二阶贝塞尔曲线(1个控制点).三阶贝塞尔曲线(2个控制点)等等. 要想对贝塞尔曲			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4APwov3.html" rel="bookmark">IOS用CGContextRef画各种图形&lpar;文字、圆、直线、弧线、矩形、扇形、椭圆、三角形、圆角矩形、贝塞尔曲线、图片&rpar;&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Graphics Context是图形上下文,可以将其理解为一块画布,我们可以在上面进行绘画操作,绘制完成后,将画布放到我们的view中显示即可,view看作是一个画框. 自己学习时实现的demo,希望对大家有帮助,具体的实现看代码,并有完美的注释解释,还有一些对我帮助的博文供大家参考.都在代码里面. 看一下demo效果图先: 自定义CustomView类,CustomView.h: [cpp]  view plain copy #import &lt;UIKit/UIKit.h&gt; #import 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ONEPP0.html" rel="bookmark">浅谈贝塞尔曲线以及iOS中粘性动画的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于贝塞尔曲线,网上相关的文章很多,这里我主要想用更简单的方法让大家理解贝塞尔曲线,当然,这仅仅是我个人的理解,如有错误的地方还请大家能够帮忙指出来,这样大家才能一起进步. 贝塞尔曲线,常用到的可分为如下几类,1阶曲线,2阶曲线(二次函数算是一种),3阶曲线,高阶曲线. 通用的方程为 这是由p0~pn这n+1个点组成的高阶方程. 但是光看这个方程的话或许大家会觉得不太理解,这东西到底能做什么? 我先逐渐的从1阶曲线讲起吧: 这里借鉴下这篇文章的几幅图片来描绘一下下列几个情况: 1阶曲线,是由两个			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/w3vPm6M.html" rel="bookmark" class="title">画弧线DrawArc的研究-我自己 -- 直线交接圆角</a>
					<div>
						procedure TForm4.Button7Click(Sender: TObject); var pwith: Integer; //画笔的宽度 hx1, hy1: Integer; //横线第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eALXv0.html" rel="bookmark" class="title">监听键盘的enter键</a>
					<div>
						$(document).keypress(function(e)              {                  switch(e.which)                  {  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qooDDM.html" rel="bookmark" class="title">Hash的应用</a>
					<div>
						重新整理了一下Hash表的应用: 首先,常用的整数哈希: 取模法 取乘法 取模顾名思义就是%p为hash值: 1 #define hash(i) (i%p) 取模顾名思义就是*p取一部分(此处用自然溢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x85DD0.html" rel="bookmark" class="title">解决Genymotion模拟器下载缓慢或者失败的方法</a>
					<div>
						1.按照常规方法下载模拟器,即必须点击ADD添加新的模拟器,这样才能在接下来的log文件中看到下载链接. 2.在用户目录下C:\Users\Cmoadne\AppData\Local\Genymobi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Zr7kG3.html" rel="bookmark" class="title">硅谷新闻10--数据缓存</a>
					<div>
						1.向SharedPreferences 中存储字符串 /** * 缓存文本数据 * * @param context * @param key * @param value */ public st ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MElXYy4.html" rel="bookmark" class="title">日志分析统计PV UV  独立IP</a>
					<div>
						pv一般都是统计指定页面的点击量,这里用首页来计算 grep &quot;/index.php&quot; /var/log/nginx/access.log | wc -l uv是统计指定页面上真是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RwOY93.html" rel="bookmark" class="title">Android 布局学习之&mdash;&mdash;Layout&lpar;布局&rpar;详解二（常见布局和布局参数）</a>
					<div>
						[Android布局学习系列]   1.Android 布局学习之——Layout(布局)详解一   2.Android 布局学习之——Layout(布局)详解二(常见布局和布局参数)   3.And ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPPKo4.html" rel="bookmark" class="title">centos7&period;0安装redis扩展</a>
					<div>
						1.下载 下载地址:https://github.com/phpredis/phpredis/ 文件名:phpredis-develop.zip 文件下载成功后,上传至/usr/local 2.安装  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QjAEkM.html" rel="bookmark" class="title">图形管线之旅 Part4</a>
					<div>
						原文:&lt;A trip through the Graphics Pipeline 2011&gt; 翻译:往昔之剑 转载请注明出处 欢迎回来.上个部分是关于vertex shader的,还带有一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWrxYL4.html" rel="bookmark" class="title">饿了么移动APP的架构演进</a>
					<div>
						0 引言 时代演进,技术也随之发展.到今天,APP已然成为绝大多数互联网企业用来获取用户的核心渠道.与此同时,伴随着业务量的增长,愈来愈大.愈来愈多的APP也在不断地.持续地挑战着每一个移动端研发人员 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41GYyG0.html" rel="bookmark" class="title">C&num;基础知识简单梳理</a>
					<div>
						C#基础知识简单梳理 本文是转发博友的总结,方便自己以后随时温习: 1.值类型和引用类型 1.1堆和栈 简单的说值类型存放在堆栈上面,引用类型的数据存放在托管堆上面(它的引用地址却存放在堆栈上面)!  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k6ZGLM.html" rel="bookmark" class="title">Linux学习笔记&amp;lt&semi;十六&amp;gt&semi;&mdash;&mdash;进程管理</a>
					<div>
						Process/Thread Model Stopped:进程收到停止信号后停止运行 Ready:正在运行 Executing正在运行队列中等待 Uninterruptible sleep:不可终端指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NXeQZ0.html" rel="bookmark" class="title">小米做公司自媒体将带来媒体春天</a>
					<div>
						文/阳淼 山寨发布会创始人 在昨天召开的媒体训练营&quot;新媒体的商业化和产品化&quot;大会上,小米公司创始人黎万强又有惊世之言,&quot;每个公司都是自媒体&quot;.由于小米公司在品牌 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bLJYk4.html" rel="bookmark" class="title">TWaver3D直线、曲线、曲面的绘制</a>
					<div>
						插播一则广告(长期有效) TWaver需要在武汉招JavaScript工程师若干 要求:对前端技术(JavasScript.HTML.CSS),对可视化技术(Canvas.WebGL)有浓厚的兴趣 基 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3w5peRM.html" rel="bookmark" class="title">mknod用法以及主次设备号【转】</a>
					<div>
						转自:http://www.cnblogs.com/hnrainll/archive/2011/06/10/2077583.html mknod 用途 创建特殊文件. mknod Name { b | ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YWlma4.html" rel="bookmark" class="title">阿里云学习笔记1</a>
					<div>
						1.新建的网站程序附加到iisexpress.exe上 2.创建bucket,putObject和Multipart Upload演示例子 案例下载:http://files.cnblogs.com/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVWOYj0.html" rel="bookmark" class="title">多个so中模板单例的多次实例化</a>
					<div>
						在Android打包项目时,发现登录功能不能使用了,logcat中也没发现什么问题,最后一行一行log定位到了问题.原来是一个so文件中的构造函数被初始化二次!   这个单例是通过继承模板来实现的(暂 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoXA2w0.html" rel="bookmark" class="title">收音机的镜频干扰</a>
					<div>
						收音机接收电台信号,经过本机本振混频得到中频后,再提取音频信号.即收音机最终只对某个固定的中频进行处理,普通调幅收音机的本机振荡频率-接收频率=455KHz(455KHz是中频,以前的国产收音机使用4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX1LJX0.html" rel="bookmark" class="title">&lpar;7&rpar;python tkinter-消息框、对话框</a>
					<div>
						消息框 导入 import tkinter import tkinter.messagebox #这个是消息框,对话框的关键 提示消息框 tkinter.messagebox.showinfo('提示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wDPJR4.html" rel="bookmark" class="title">U盘数据恢复</a>
					<div>
						U盘数据恢复 查看U盘属性,如果已用空间不为0,那么可以使用以下方法. 在U盘里面新建一个txt,文档内容为attrib -s -h /s /d 把txt后缀改成bat,双击运行即可					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
